﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Windows.Forms;

namespace ProwlLibTest
{
    public partial class ProwlClient : Form
        {
        private int Prowl;
        public ProwlClient()
        {
            InitializeComponent();
            lblVer.Text = prowlVersionA();
            cbPriority.SelectedIndex = 2;
        }

        #region Invokes from external library
        [DllImport("prowl.dll", CharSet = CharSet.Auto)]
            [return: MarshalAs(UnmanagedType.AnsiBStr)]
            private static extern string prowlVersionW();

        [DllImport("prowl.dll")]        
        private static extern string prowlVersionA();
                
        [DllImport("prowl.dll")]
        private static extern int prowlInitA(string AppName,string APIKey,string ProviderKey,bool VerifyAPIKey);        

        [DllImport("prowl.dll")]
        private static extern int prowlSendA(int  Handle, int Priority, string Event, string MessageToSend);

        #endregion

        private int Priority
            {
            get
                {
                return (cbPriority.SelectedIndex - 2);
                }
            }

        private void btnVerify_Click(object sender, EventArgs e)
            {
            string APIKey = editAPIKey.Text;
            Prowl = prowlInitA(@"Client.exe", APIKey, @"", true);
            if (Prowl < 1)
                {
                MessageBox.Show(@"Error : " + Prowl, @"Error");
                return;
                }
            button1.Enabled = true;
            editMessage.Enabled = true;
            editAPIKey.Enabled = false;
            btnVerify.Enabled = false;
            btnReset.Enabled = true;
            editEvent.Enabled = true;
            editApplication.Enabled = true;
            editEvent.Enabled = true;
            editMessage.Focus();
            }

        private void button1_Click(object sender, EventArgs e)
        {
            if (editMessage.Text.Equals(""))
                {
                MessageBox.Show(@"Please type a message", @"Empty message is not allowed");
                return;
                }
            if (Prowl > 0)
                {
                int ret = prowlSendA(Prowl, Priority, editEvent.Text, editMessage.Text);
                if (ret == 0)
                    {
                    MessageBox.Show(@"Successfully sent", @"Success");
                    editMessage.Text = "";
                    editMessage.Focus();
                    }
                }
        }

        private void btnReset_Click(object sender, EventArgs e)
            {
            btnReset.Enabled = false;
            button1.Enabled = false;
            editMessage.Enabled = false;
            editAPIKey.Enabled = true;
            btnVerify.Enabled = true;            
            editApplication.Enabled = false;
            editEvent.Enabled = false;

            }

        private void btnHelp_Click(object sender, EventArgs e)
            {
            Process.Start("https://fx1.net/prowllink.php");
            }

        private void btnRegister_Click(object sender, EventArgs e)
            {
            Process.Start("https://www.prowlapp.com/register.php");
            }

    }
}
